Unit KonsoleUnit;
{
   Eine Unit, um damit eine Art Konsole zu erstellen.

   Aufruf mittels
      KonsoleFormCreate()   in zwei Fassungen   (mit/ohne Angabe der captions)
}

{$mode objfpc}{$H+}

interface

uses
Classes, SysUtils, FileUtil, Forms, Controls, Graphics, ExtCtrls,
ComCtrls, StdCtrls, Buttons, LCLType;


TYPE
  TKonsoleButtonStr = array[0..8] of string;

type TKonsole=class(TForm)
 private
  KonsoleWrapButton: TToggleBox;
  KonsoleWritePermitButton: TToggleBox;
  KonsoleClearButton: TSpeedButton;
  Memo: TMemo;

  procedure KonsoleWrapButtonClick(Sender: TObject); // Zeilenumbruch?
  procedure KonsoleWritePermitButtonClick(Sender: TObject); // in Memo schreiben?
  procedure KonsoleClearButtonClick(Sender: TObject); // Memo löschen


  procedure KonsoleFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  procedure KonsoleFormResize(Sender: TObject);
  procedure KonsoleResize;
  procedure KonsoleFormDestroy(Sender:TObject);
  procedure MainFormClose(Sender: TObject; var CloseAction: TCloseAction);

public
  constructor createNew(TheOwner: TComponent);
  procedure KonsoleFormCreate(f:Tform; Open_, Show_: TControl; Sender: TObject);
  end;


var Konsole:TKonsole;
      Zeilen: TStrings;


const
   ButtonStr : TKonsoleButtonStr =
      ('Close Konsole', 'Open Konsole', 'Hide Konsole', 'Show Konsole',
       'Wrap', 'No Wrap', 'Writing', 'No Writing', 'Clear');
   maxEvent:integer = 500; // maximale Zeilenanzahl in der Memo

procedure Eventln(s:string);

// 220:▄ 223:▀  219:█ 254:■   ▄■▄■▄■▄■▄
//▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■▄■▀■


//▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀
//▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀

implementation
  Uses Math, Dialogs, LCLIntf;
//▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀
//▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀

{ $R *.lfm}

const
  KonsoleRect:TRect = (left:200; top:200; right:500; bottom:700);
            // zum Speichern der Konsole-Größe und -Position

  WritePermit:boolean = true;
          { damit kann man in die Memo auch schreiben, Text auswählen, löschen,
            verschieben etc. }
var
  alt_OpenCaption, alt_ShowCaption:string;
  Alt_Close: TCloseEvent;
  HauptForm:TCustomform;

   { TKonsole }

   constructor TKonsole.createNew(TheOwner: TComponent);
    begin
        inherited createNew(TheOwner);
    end;
   procedure TKonsole.KonsoleFormCreate(f:Tform; Open_, Show_: TControl; Sender: TObject);
     var h:integer;  // Button-Höhe
    begin
        NotifyUser(Sender.classname, idDialogBase);
         Zeilen:=TstringList.Create;
         h:=Zeilen.count;
         Hauptform:=f; h:=24;


        Konsole:=TKonsole.CreateNew(nil);
              // createnew, weil in der lpr-Datei angegeben ist
              //   RequireDerivedFormResource := True;
       with Konsole do
         begin
           alt_Close:=Hauptform.OnClose;
           HauptForm.Onclose:=@MainFormClose;

           BoundsRect:=KonsoleRect;
           borderstyle := bsSizeable; Caption:='Konsole';
           show;
           onResize:=@KonsoleFormResize;
           onDestroy := @KonsoleFormDestroy;
     KonsoleClearButton :=TSpeedButton.Create(self);
             with KonsoleClearButton do
               begin
                 parent:=Konsole;
                 setbounds(155,5,50,h);
                 onclick:=@KonsoleClearButtonClick;
                 show;
                 caption := ButtonStr[8];
               end;
     Memo:=TMemo.create(self);
                 with Memo do
                   begin
                     Parent:=Konsole;
                     Align:=albottom;
                     ScrollBars:=ssAutoBoth;
                     KonsoleResize;
                     OnKeyDown := @KonsoleFormKeyDown; // um evtl. Texteingaben zu unterbinden
                     show;
                   end;
       KonsoleWrapButton:=TToggleBox.Create(Konsole);
         with KonsoleWrapButton do
           begin
                parent:=Konsole;
                setbounds(5,5,75, h);
                caption := ButtonStr[4+byte(not Memo.wordwrap)];
                onclick:=@KonsoleWrapButtonclick;
                 show;
           end;
       KonsoleWritePermitButton:=TToggleBox.Create(Konsole);
         with KonsoleWritePermitButton do
           begin
                parent:=Konsole;
                setbounds(80,5,75, h);
                caption := ButtonStr[6+byte(not WritePermit)];
                onclick:=@KonsoleWritePermitButtonclick;
                 show;
           end;
         end;
     end;

   procedure TKonsole.KonsoleFormDestroy(Sender: TObject);
     begin
        HauptForm.onclose:= Alt_Close;
       KonsoleRect:= BoundsRect; // Formsize speichern
       KonsoleWritePermitButton.free;
       KonsoleClearButton.free;
       KonsoleWrapButton.free;
       Zeilen.Free;
       inherited;
       Konsole:=nil;
     end;
   procedure TKonsole.MainFormClose(Sender: TObject; var CloseAction: TCloseAction);
     begin
        if konsole <> nil
              then Konsole.free;
        HauptForm.close;
     end;


procedure TKonsole.KonsoleWrapButtonClick(Sender: TObject);
  begin with Memo do
    begin wordwrap:= not wordwrap;
       KonsoleWrapButton.caption:=ButtonStr[4+byte(not wordwrap)];
    end;
  end;
procedure TKonsole.KonsoleWritePermitButtonClick(Sender: TObject);
  begin WritePermit := not WritePermit;
    KonsoleWritePermitButton.caption := ButtonStr[6+byte(not WritePermit)];
  end;
procedure TKonsole.KonsoleClearButtonClick(Sender: TObject);
  begin
    Zeilen.clear;
    Memo.lines.clear;
  end;

procedure TKonsole.KonsoleFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not WritePermit then key:=0; // => keine Tastatureingaben in der Memo!
end;
procedure TKonsole.KonsoleFormResize(Sender: TObject);
  begin
     KonsoleResize;
  end;
procedure TKonsole.KonsoleResize;
  begin
    Memo.Height:=height-58+KonsoleClearButton.height;
  end;

procedure EventLn(s:string);
   var i:integer;
   const busy:boolean = false;
  begin
    if Konsole=nil then exit;
    if busy then exit;
    busy :=true;
    with konsole.memo do
      begin
        if zeilen.count > maxEvent-1 then
            for i:=1 to max(1,maxevent div 10) do
              Zeilen.delete(0);
        lines.assign(zeilen);
        lines.Add(s);
        zeilen.add(s);
     end;
     busy:=false;
  end;


end.

